ballotblock/urls.py
from django.urls import path
from ballotblock import views
from django.urls import include
from django.conf.urls.static import static
from ballotblock import settings

urlpatterns = [
    path('', views.home, name='home'),
    path('about_us/', views.about_us, name='about_us'),
    path('accounts/', include('django.contrib.auth.urls')),
    path('chain/', include('chain.urls')),
    path('election/', include('election.urls')),
    path('vote/', include('vote.urls')),
    path('documentation/', include('documentation.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

vote/urls.py
from django.urls import path
from vote import views

urlpatterns = [
    path('vote', views.vote, name='vote'),
    path('election_results', views.election_results, name='election_results'),
]

election/models.py
from django.db import models, connections
from datetime import datetime
from django.utils import timezone
from django.contrib.auth.models import User
from django.core.validators import MaxValueValidator, MinValueValidator
from decimal import Decimal
from django.contrib.auth.models import User
from django.core.exceptions import ValidationError

def present_or_future_date_starttime(start_time):
    if start_time < datetime.now():
        raise ValidationError("Check if the start time is set properly.")

def present_or_future_date_endtime(end_time):
    if end_time < datetime.now():
        raise ValidationError("Check if the end time is set properly.")

class ElectionConfig(models.Model):
    description = models.CharField(max_length=100, null=False, blank=False, default='Generic Election')
    start_time = models.DateTimeField(null=False, blank=False)
    end_time = models.DateTimeField(null=False, blank=False)
    block_time_generation = models.IntegerField(default=2)
    guess_rate = models.DecimalField(null=False, blank=False, max_digits=5,decimal_places=4, validators=[MinValueValidator(Decimal('0.0001')), MaxValueValidator(Decimal('0.9999'))], default=Decimal('0.4'))
    min_votes_in_block = models.IntegerField(null=False, blank=False, default=6)
    min_votes_in_last_block = models.IntegerField(null=False, blank=False, default=6)
    attendance_rate = models.DecimalField(null=False, blank=False, max_digits=3, decimal_places=2, validators=[MinValueValidator(Decimal('0.01')), MaxValueValidator(Decimal('0.99'))], default=Decimal('0.5'))
    locked = models.BooleanField(default=False)

    def __str__(self):
        return self.description


class Elector(models.Model):
    user = models.ForeignKey(User, null=False, blank=False, on_delete=models.CASCADE)

    def __str__(self):
        return self.user.get_full_name()

class Position(models.Model):
    description = models.CharField(max_length=100, unique=True, null=False, blank=False)
    quantity = models.IntegerField(null=False, blank=False, default=1)

    def __str__(self):
        return self.description

class Candidate(models.Model):
    name = models.CharField(max_length=300, unique=True, null=False, blank=False)
    position = models.ForeignKey(Position, null=False, blank=False, on_delete=models.CASCADE)

    def __str__(self):
        return self.name

vote/models.py
from django.db import models
from election.models import Elector, Candidate

class Voted(models.Model):
    elector = models.OneToOneField(Elector, blank=False, null=False, unique=True, on_delete=models.CASCADE)
    hash_val= models.CharField(max_length=200, null=True, blank=False, default=None)
    system_signature = models.TextField(null=True, blank=True)

class CandidateVote(models.Model):
    candidate = models.OneToOneField(Candidate, blank=False, null=False, unique=True, on_delete=models.CASCADE)
    quantity = models.IntegerField(null=False, blank=False, default=0)

vote/views.py
from django.shortcuts import render
from election.models import Position, Candidate, Elector
from vote.models import Voted, CandidateVote
from django.contrib.auth.models import User
from django.db import transaction
from django.contrib.auth.decorators import login_required
import datetime
from election.business import ElectionBusiness
from django.contrib import messages
from django.core.serializers.json import DjangoJSONEncoder
import json
from django.core.signing import Signer


# Create your views here.

@login_required
@transaction.atomic
def vote(request, template_name='vote.html'):
    eb = ElectionBusiness()
    context = {}
    signer = Signer()
    if eb.isOccurring():
        # Check if elector already voted.
        if Voted.objects.filter(elector__user=request.user).count() > 0:
            messages.warning(request, 'You have already voted.')   
            return render(request, template_name, context)

        positions = Position.objects.all()
        if request.method == 'POST':
            try:
                for p in positions:
                    pname = 'position{}'.format(p.id)
                    candidate_id = request.POST.get(pname,"")
                    candidate = Candidate.objects.get(id=int(candidate_id))
                    cv, created = CandidateVote.objects.get_or_create(candidate=candidate)
                    cv.quantity = cv.quantity + 1
                    cv.save()
                elector = Elector.objects.get(user=request.user)
                voted = Voted.objects.create(elector=elector)
                voted.system_signature = signer.sign(str(elector.id))
                voted.save()
                messages.success(request, 'Your vote was registred successfully')
            except Exception as e:
                messages.error(request, str(e))
        else:
            context['positions'] = positions
            context['quantity_of_positions'] = positions.count()
    else:
        messages.error(request, 'Election has finished.')
    
    return render(request, template_name, context)


def election_results(request, template_name='election_results.html'):

    data = []
    positions = Position.objects.all()
    for p in positions:
        candidate_vote = CandidateVote.objects.filter(candidate__position=p).values('candidate__name', 'candidate__position__description', 'quantity' )
        candidate_vote_json_str = json.dumps(list(candidate_vote), cls=DjangoJSONEncoder)
        data.append(candidate_vote_json_str)
  
    return render(request, template_name, context={'results_data':json.dumps(data, cls=DjangoJSONEncoder), 'positions':positions})

vote/templates/election_results.html
{% extends 'base.html' %}
{% load static %}

{% block extrahead %}
	{{block.super}}
	<script src="{% static 'chartsjs/2.8.0/js/Chart.bundle.min.js' %}"></script>
{% endblock%}

{% block breadcrumb %}
	<nav aria-label="breadcrumb">
			<ol class="breadcrumb">
				<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
				<li class="breadcrumb-item">Election</li>
				<li class="breadcrumb-item active" aria-current="page">Results</li>
			</ol>
	</nav>
{% endblock breadcrumb %}

{% block content %}
<style>
    .breadcrumb{
        background-color:#383636;
        color:#ffffff;
    }
</style>

	<div class="row">
	{% for position in positions %}
			<div class="col-md-6">
				<canvas id="chart_position_{{ forloop.counter0 }}" width="400" height="400" title="{{position.description}}"></canvas>
			</div>
			{% if forloop.last %}
				</div>
			{% else %}
				{% if forloop.counter|divisibleby:"2" %}
					</div><div class="row">
				{% endif %}
			{% endif %}
	{% endfor %}



<script>
	function drawChart(elementId, data) {
		var ctx = document.getElementById(elementId).getContext('2d');
		var chart_title = $("#"+elementId).attr("title");
		var chart_quantity = [];
		var chart_candidate = [];
		var jsonObj = JSON.parse(data);
		for (i=0; i < jsonObj.length; i++) {
			chart_quantity.push(jsonObj[i].quantity);
			chart_candidate.push(jsonObj[i].candidate__name);
		}
		var myChart = new Chart(ctx, {
			type: 'bar',
			data: {
				labels: chart_candidate,
				datasets: [{
					label:'',
					data: chart_quantity,
					backgroundColor:["rgba(230, 25, 75, 0.2)", "rgba(60, 180, 75, 0.2)", "rgba(255, 225, 25, 0.2)", "rgba(0, 130, 200, 0.2)", "rgba(245, 130, 48, 0.2)", "rgba(145, 30, 180, 0.2)", "rgba(70, 240, 240, 0.2)", "rgba(240, 50, 230, 0.2)", "rgba(210, 245, 60, 0.2)", "rgba(250, 190, 190, 0.2)", "rgba(0, 128, 128, 0.2)", "rgba(230, 190, 255, 0.2)", "rgba(170, 110, 40, 0.2)", "rgba(255, 250, 200, 0.2)", "rgba(128, 0, 0, 0.2)", "rgba(170, 255, 195, 0.2)", "rgba(128, 128, 0, 0.2)", "rgba(255, 215, 180, 0.2)", "rgba(0, 0, 128, 0.2)", "rgba(128, 128, 128, 0.2)", "rgba(0, 0, 0, 0.2)"],
					borderColor:["rgb(230, 25, 75)", "rgb(60, 180, 75)", "rgb(255, 225, 25)", "rgb(0, 130, 200)", "rgb(245, 130, 48)", "rgb(145, 30, 180)", "rgb(70, 240, 240)", "rgb(240, 50, 230)", "rgb(210, 245, 60)", "rgb(250, 190, 190)", "rgb(0, 128, 128)", "rgb(230, 190, 255)", "rgb(170, 110, 40)", "rgb(255, 250, 200)", "rgb(128, 0, 0)", "rgb(170, 255, 195)", "rgb(128, 128, 0)", "rgb(255, 215, 180)", "rgb(0, 0, 128)", "rgb(128, 128, 128)", "rgb(0, 0, 0)"],
					barPercentage: 1.0,
					borderWidth: 1
				}]
			},
			options: {
				scales: {
					yAxes: [{
						ticks: {
							beginAtZero: true,
							stepSize: 1
						}
					}]
				},
				title: {
            		display: true,
            		text: chart_title
        		},
				legend: {
        			display: false
    			}
			}
		});
	}

	$( document ).ready(function() {
    	var results_data = JSON.parse('{{ results_data | escapejs }}');
		var i;
		for(i=0; i < results_data.length; i++) {
			var elementId = "chart_position_" + i;
			drawChart(elementId, results_data[i]);
		}
	});


</script>
{% endblock content %}

vote/templates/vote.html
{% extends 'base.html' %}
{% load staticfiles %}
{% block content %}
    {% if positions %}
        <form id="id_positions_form" class="form-horizontal" method="POST">
            <input id="id_quantity_of_positions" type="hidden" value="{{quantity_of_positions}}">
            {% csrf_token %}
            {% for p in positions %}
                <div class="form-group">
                    <strong>{{forloop.counter}}. {{p.description}}</strong>
                    {% for c in p.candidate_set.all|dictsort:"name"%}
                    <div class="form-check">
                        <input class="form-check-input" type="radio" name="position{{p.id}}" id="candidate{{c.id}}" value="{{c.id}}" required>
                        <label class="form-check-label" for="candidate{{c.id}}">
                            {{c.name}}
                        </label>
                    </div>
                    {% endfor %}
                </div>
            {% endfor %}
            <button type="submit" class="btn btn-primary">Vote</button>
        </form>
    {% endif %}

{% endblock content %}